"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IAMService = exports.makeIAMService = void 0;
/**
 * @since 1.0.0
 */
const client_iam_1 = require("@aws-sdk/client-iam");
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Errors_js_1 = require("./Errors.js");
const Instance = __importStar(require("./IAMClientInstance.js"));
const IAMServiceConfig = __importStar(require("./IAMServiceConfig.js"));
const commands = {
    AddClientIDToOpenIDConnectProviderCommand: client_iam_1.AddClientIDToOpenIDConnectProviderCommand,
    AddRoleToInstanceProfileCommand: client_iam_1.AddRoleToInstanceProfileCommand,
    AddUserToGroupCommand: client_iam_1.AddUserToGroupCommand,
    AttachGroupPolicyCommand: client_iam_1.AttachGroupPolicyCommand,
    AttachRolePolicyCommand: client_iam_1.AttachRolePolicyCommand,
    AttachUserPolicyCommand: client_iam_1.AttachUserPolicyCommand,
    ChangePasswordCommand: client_iam_1.ChangePasswordCommand,
    CreateAccessKeyCommand: client_iam_1.CreateAccessKeyCommand,
    CreateAccountAliasCommand: client_iam_1.CreateAccountAliasCommand,
    CreateGroupCommand: client_iam_1.CreateGroupCommand,
    CreateInstanceProfileCommand: client_iam_1.CreateInstanceProfileCommand,
    CreateLoginProfileCommand: client_iam_1.CreateLoginProfileCommand,
    CreateOpenIDConnectProviderCommand: client_iam_1.CreateOpenIDConnectProviderCommand,
    CreatePolicyCommand: client_iam_1.CreatePolicyCommand,
    CreatePolicyVersionCommand: client_iam_1.CreatePolicyVersionCommand,
    CreateRoleCommand: client_iam_1.CreateRoleCommand,
    CreateSAMLProviderCommand: client_iam_1.CreateSAMLProviderCommand,
    CreateServiceLinkedRoleCommand: client_iam_1.CreateServiceLinkedRoleCommand,
    CreateServiceSpecificCredentialCommand: client_iam_1.CreateServiceSpecificCredentialCommand,
    CreateUserCommand: client_iam_1.CreateUserCommand,
    CreateVirtualMFADeviceCommand: client_iam_1.CreateVirtualMFADeviceCommand,
    DeactivateMFADeviceCommand: client_iam_1.DeactivateMFADeviceCommand,
    DeleteAccessKeyCommand: client_iam_1.DeleteAccessKeyCommand,
    DeleteAccountAliasCommand: client_iam_1.DeleteAccountAliasCommand,
    DeleteAccountPasswordPolicyCommand: client_iam_1.DeleteAccountPasswordPolicyCommand,
    DeleteGroupCommand: client_iam_1.DeleteGroupCommand,
    DeleteGroupPolicyCommand: client_iam_1.DeleteGroupPolicyCommand,
    DeleteInstanceProfileCommand: client_iam_1.DeleteInstanceProfileCommand,
    DeleteLoginProfileCommand: client_iam_1.DeleteLoginProfileCommand,
    DeleteOpenIDConnectProviderCommand: client_iam_1.DeleteOpenIDConnectProviderCommand,
    DeletePolicyCommand: client_iam_1.DeletePolicyCommand,
    DeletePolicyVersionCommand: client_iam_1.DeletePolicyVersionCommand,
    DeleteRoleCommand: client_iam_1.DeleteRoleCommand,
    DeleteRolePermissionsBoundaryCommand: client_iam_1.DeleteRolePermissionsBoundaryCommand,
    DeleteRolePolicyCommand: client_iam_1.DeleteRolePolicyCommand,
    DeleteSAMLProviderCommand: client_iam_1.DeleteSAMLProviderCommand,
    DeleteSSHPublicKeyCommand: client_iam_1.DeleteSSHPublicKeyCommand,
    DeleteServerCertificateCommand: client_iam_1.DeleteServerCertificateCommand,
    DeleteServiceLinkedRoleCommand: client_iam_1.DeleteServiceLinkedRoleCommand,
    DeleteServiceSpecificCredentialCommand: client_iam_1.DeleteServiceSpecificCredentialCommand,
    DeleteSigningCertificateCommand: client_iam_1.DeleteSigningCertificateCommand,
    DeleteUserCommand: client_iam_1.DeleteUserCommand,
    DeleteUserPermissionsBoundaryCommand: client_iam_1.DeleteUserPermissionsBoundaryCommand,
    DeleteUserPolicyCommand: client_iam_1.DeleteUserPolicyCommand,
    DeleteVirtualMFADeviceCommand: client_iam_1.DeleteVirtualMFADeviceCommand,
    DetachGroupPolicyCommand: client_iam_1.DetachGroupPolicyCommand,
    DetachRolePolicyCommand: client_iam_1.DetachRolePolicyCommand,
    DetachUserPolicyCommand: client_iam_1.DetachUserPolicyCommand,
    DisableOrganizationsRootCredentialsManagementCommand: client_iam_1.DisableOrganizationsRootCredentialsManagementCommand,
    DisableOrganizationsRootSessionsCommand: client_iam_1.DisableOrganizationsRootSessionsCommand,
    EnableMFADeviceCommand: client_iam_1.EnableMFADeviceCommand,
    EnableOrganizationsRootCredentialsManagementCommand: client_iam_1.EnableOrganizationsRootCredentialsManagementCommand,
    EnableOrganizationsRootSessionsCommand: client_iam_1.EnableOrganizationsRootSessionsCommand,
    GenerateCredentialReportCommand: client_iam_1.GenerateCredentialReportCommand,
    GenerateOrganizationsAccessReportCommand: client_iam_1.GenerateOrganizationsAccessReportCommand,
    GenerateServiceLastAccessedDetailsCommand: client_iam_1.GenerateServiceLastAccessedDetailsCommand,
    GetAccessKeyLastUsedCommand: client_iam_1.GetAccessKeyLastUsedCommand,
    GetAccountAuthorizationDetailsCommand: client_iam_1.GetAccountAuthorizationDetailsCommand,
    GetAccountPasswordPolicyCommand: client_iam_1.GetAccountPasswordPolicyCommand,
    GetAccountSummaryCommand: client_iam_1.GetAccountSummaryCommand,
    GetContextKeysForCustomPolicyCommand: client_iam_1.GetContextKeysForCustomPolicyCommand,
    GetContextKeysForPrincipalPolicyCommand: client_iam_1.GetContextKeysForPrincipalPolicyCommand,
    GetCredentialReportCommand: client_iam_1.GetCredentialReportCommand,
    GetGroupCommand: client_iam_1.GetGroupCommand,
    GetGroupPolicyCommand: client_iam_1.GetGroupPolicyCommand,
    GetInstanceProfileCommand: client_iam_1.GetInstanceProfileCommand,
    GetLoginProfileCommand: client_iam_1.GetLoginProfileCommand,
    GetMFADeviceCommand: client_iam_1.GetMFADeviceCommand,
    GetOpenIDConnectProviderCommand: client_iam_1.GetOpenIDConnectProviderCommand,
    GetOrganizationsAccessReportCommand: client_iam_1.GetOrganizationsAccessReportCommand,
    GetPolicyCommand: client_iam_1.GetPolicyCommand,
    GetPolicyVersionCommand: client_iam_1.GetPolicyVersionCommand,
    GetRoleCommand: client_iam_1.GetRoleCommand,
    GetRolePolicyCommand: client_iam_1.GetRolePolicyCommand,
    GetSAMLProviderCommand: client_iam_1.GetSAMLProviderCommand,
    GetSSHPublicKeyCommand: client_iam_1.GetSSHPublicKeyCommand,
    GetServerCertificateCommand: client_iam_1.GetServerCertificateCommand,
    GetServiceLastAccessedDetailsCommand: client_iam_1.GetServiceLastAccessedDetailsCommand,
    GetServiceLastAccessedDetailsWithEntitiesCommand: client_iam_1.GetServiceLastAccessedDetailsWithEntitiesCommand,
    GetServiceLinkedRoleDeletionStatusCommand: client_iam_1.GetServiceLinkedRoleDeletionStatusCommand,
    GetUserCommand: client_iam_1.GetUserCommand,
    GetUserPolicyCommand: client_iam_1.GetUserPolicyCommand,
    ListAccessKeysCommand: client_iam_1.ListAccessKeysCommand,
    ListAccountAliasesCommand: client_iam_1.ListAccountAliasesCommand,
    ListAttachedGroupPoliciesCommand: client_iam_1.ListAttachedGroupPoliciesCommand,
    ListAttachedRolePoliciesCommand: client_iam_1.ListAttachedRolePoliciesCommand,
    ListAttachedUserPoliciesCommand: client_iam_1.ListAttachedUserPoliciesCommand,
    ListEntitiesForPolicyCommand: client_iam_1.ListEntitiesForPolicyCommand,
    ListGroupPoliciesCommand: client_iam_1.ListGroupPoliciesCommand,
    ListGroupsCommand: client_iam_1.ListGroupsCommand,
    ListGroupsForUserCommand: client_iam_1.ListGroupsForUserCommand,
    ListInstanceProfileTagsCommand: client_iam_1.ListInstanceProfileTagsCommand,
    ListInstanceProfilesCommand: client_iam_1.ListInstanceProfilesCommand,
    ListInstanceProfilesForRoleCommand: client_iam_1.ListInstanceProfilesForRoleCommand,
    ListMFADeviceTagsCommand: client_iam_1.ListMFADeviceTagsCommand,
    ListMFADevicesCommand: client_iam_1.ListMFADevicesCommand,
    ListOpenIDConnectProviderTagsCommand: client_iam_1.ListOpenIDConnectProviderTagsCommand,
    ListOpenIDConnectProvidersCommand: client_iam_1.ListOpenIDConnectProvidersCommand,
    ListOrganizationsFeaturesCommand: client_iam_1.ListOrganizationsFeaturesCommand,
    ListPoliciesCommand: client_iam_1.ListPoliciesCommand,
    ListPoliciesGrantingServiceAccessCommand: client_iam_1.ListPoliciesGrantingServiceAccessCommand,
    ListPolicyTagsCommand: client_iam_1.ListPolicyTagsCommand,
    ListPolicyVersionsCommand: client_iam_1.ListPolicyVersionsCommand,
    ListRolePoliciesCommand: client_iam_1.ListRolePoliciesCommand,
    ListRoleTagsCommand: client_iam_1.ListRoleTagsCommand,
    ListRolesCommand: client_iam_1.ListRolesCommand,
    ListSAMLProviderTagsCommand: client_iam_1.ListSAMLProviderTagsCommand,
    ListSAMLProvidersCommand: client_iam_1.ListSAMLProvidersCommand,
    ListSSHPublicKeysCommand: client_iam_1.ListSSHPublicKeysCommand,
    ListServerCertificateTagsCommand: client_iam_1.ListServerCertificateTagsCommand,
    ListServerCertificatesCommand: client_iam_1.ListServerCertificatesCommand,
    ListServiceSpecificCredentialsCommand: client_iam_1.ListServiceSpecificCredentialsCommand,
    ListSigningCertificatesCommand: client_iam_1.ListSigningCertificatesCommand,
    ListUserPoliciesCommand: client_iam_1.ListUserPoliciesCommand,
    ListUserTagsCommand: client_iam_1.ListUserTagsCommand,
    ListUsersCommand: client_iam_1.ListUsersCommand,
    ListVirtualMFADevicesCommand: client_iam_1.ListVirtualMFADevicesCommand,
    PutGroupPolicyCommand: client_iam_1.PutGroupPolicyCommand,
    PutRolePermissionsBoundaryCommand: client_iam_1.PutRolePermissionsBoundaryCommand,
    PutRolePolicyCommand: client_iam_1.PutRolePolicyCommand,
    PutUserPermissionsBoundaryCommand: client_iam_1.PutUserPermissionsBoundaryCommand,
    PutUserPolicyCommand: client_iam_1.PutUserPolicyCommand,
    RemoveClientIDFromOpenIDConnectProviderCommand: client_iam_1.RemoveClientIDFromOpenIDConnectProviderCommand,
    RemoveRoleFromInstanceProfileCommand: client_iam_1.RemoveRoleFromInstanceProfileCommand,
    RemoveUserFromGroupCommand: client_iam_1.RemoveUserFromGroupCommand,
    ResetServiceSpecificCredentialCommand: client_iam_1.ResetServiceSpecificCredentialCommand,
    ResyncMFADeviceCommand: client_iam_1.ResyncMFADeviceCommand,
    SetDefaultPolicyVersionCommand: client_iam_1.SetDefaultPolicyVersionCommand,
    SetSecurityTokenServicePreferencesCommand: client_iam_1.SetSecurityTokenServicePreferencesCommand,
    SimulateCustomPolicyCommand: client_iam_1.SimulateCustomPolicyCommand,
    SimulatePrincipalPolicyCommand: client_iam_1.SimulatePrincipalPolicyCommand,
    TagInstanceProfileCommand: client_iam_1.TagInstanceProfileCommand,
    TagMFADeviceCommand: client_iam_1.TagMFADeviceCommand,
    TagOpenIDConnectProviderCommand: client_iam_1.TagOpenIDConnectProviderCommand,
    TagPolicyCommand: client_iam_1.TagPolicyCommand,
    TagRoleCommand: client_iam_1.TagRoleCommand,
    TagSAMLProviderCommand: client_iam_1.TagSAMLProviderCommand,
    TagServerCertificateCommand: client_iam_1.TagServerCertificateCommand,
    TagUserCommand: client_iam_1.TagUserCommand,
    UntagInstanceProfileCommand: client_iam_1.UntagInstanceProfileCommand,
    UntagMFADeviceCommand: client_iam_1.UntagMFADeviceCommand,
    UntagOpenIDConnectProviderCommand: client_iam_1.UntagOpenIDConnectProviderCommand,
    UntagPolicyCommand: client_iam_1.UntagPolicyCommand,
    UntagRoleCommand: client_iam_1.UntagRoleCommand,
    UntagSAMLProviderCommand: client_iam_1.UntagSAMLProviderCommand,
    UntagServerCertificateCommand: client_iam_1.UntagServerCertificateCommand,
    UntagUserCommand: client_iam_1.UntagUserCommand,
    UpdateAccessKeyCommand: client_iam_1.UpdateAccessKeyCommand,
    UpdateAccountPasswordPolicyCommand: client_iam_1.UpdateAccountPasswordPolicyCommand,
    UpdateAssumeRolePolicyCommand: client_iam_1.UpdateAssumeRolePolicyCommand,
    UpdateGroupCommand: client_iam_1.UpdateGroupCommand,
    UpdateLoginProfileCommand: client_iam_1.UpdateLoginProfileCommand,
    UpdateOpenIDConnectProviderThumbprintCommand: client_iam_1.UpdateOpenIDConnectProviderThumbprintCommand,
    UpdateRoleCommand: client_iam_1.UpdateRoleCommand,
    UpdateRoleDescriptionCommand: client_iam_1.UpdateRoleDescriptionCommand,
    UpdateSAMLProviderCommand: client_iam_1.UpdateSAMLProviderCommand,
    UpdateSSHPublicKeyCommand: client_iam_1.UpdateSSHPublicKeyCommand,
    UpdateServerCertificateCommand: client_iam_1.UpdateServerCertificateCommand,
    UpdateServiceSpecificCredentialCommand: client_iam_1.UpdateServiceSpecificCredentialCommand,
    UpdateSigningCertificateCommand: client_iam_1.UpdateSigningCertificateCommand,
    UpdateUserCommand: client_iam_1.UpdateUserCommand,
    UploadSSHPublicKeyCommand: client_iam_1.UploadSSHPublicKeyCommand,
    UploadServerCertificateCommand: client_iam_1.UploadServerCertificateCommand,
    UploadSigningCertificateCommand: client_iam_1.UploadSigningCertificateCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
exports.makeIAMService = effect_1.Effect.gen(function* () {
    const client = yield* Instance.IAMClientInstance;
    return commons_1.Service.fromClientAndCommands(client, commands, {
        errorTags: Errors_js_1.AllServiceErrors,
        resolveClientConfig: IAMServiceConfig.toIAMClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
class IAMService extends effect_1.Effect.Tag("@effect-aws/client-iam/IAMService")() {
    static defaultLayer = effect_1.Layer.effect(this, exports.makeIAMService).pipe(effect_1.Layer.provide(Instance.layer));
    static layer = (config) => effect_1.Layer.effect(this, exports.makeIAMService).pipe(effect_1.Layer.provide(Instance.layer), effect_1.Layer.provide(IAMServiceConfig.setIAMServiceConfig(config)));
    static baseLayer = (evaluate) => effect_1.Layer.effect(this, exports.makeIAMService).pipe(effect_1.Layer.provide(effect_1.Layer.effect(Instance.IAMClientInstance, effect_1.Effect.map(IAMServiceConfig.toIAMClientConfig, evaluate))));
}
exports.IAMService = IAMService;
//# sourceMappingURL=IAMService.js.map