"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.toIAMClientConfig = exports.setIAMServiceConfig = exports.withIAMServiceConfig = void 0;
const commons_1 = require("@effect-aws/commons");
const effect_1 = require("effect");
const Function_1 = require("effect/Function");
const GlobalValue_1 = require("effect/GlobalValue");
/**
 * @since 1.0.0
 * @category iam service config
 */
const currentIAMServiceConfig = (0, GlobalValue_1.globalValue)("@effect-aws/client-iam/currentIAMServiceConfig", () => effect_1.FiberRef.unsafeMake({}));
/**
 * @since 1.0.0
 * @category iam service config
 */
exports.withIAMServiceConfig = (0, Function_1.dual)(2, (effect, config) => effect_1.Effect.locally(effect, currentIAMServiceConfig, config));
/**
 * @since 1.0.0
 * @category iam service config
 */
const setIAMServiceConfig = (config) => effect_1.Layer.locallyScoped(currentIAMServiceConfig, config);
exports.setIAMServiceConfig = setIAMServiceConfig;
/**
 * @since 1.0.0
 * @category adapters
 */
exports.toIAMClientConfig = effect_1.Effect.gen(function* () {
    const { logger: serviceLogger, ...config } = yield* effect_1.FiberRef.get(currentIAMServiceConfig);
    const logger = serviceLogger === true
        ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.defaultServiceLogger)
        : (serviceLogger ? yield* commons_1.ServiceLogger.toClientLogger(commons_1.ServiceLogger.make(serviceLogger)) : undefined);
    return { logger, ...config };
});
//# sourceMappingURL=IAMServiceConfig.js.map