/**
 * @since 1.0.0
 */
import type { IAMClientConfig } from "@aws-sdk/client-iam";
import { Effect, Layer } from "effect";
import type { IAMService } from "./IAMService.js";
/**
 * @since 1.0.0
 * @category iam service config
 */
export declare const withIAMServiceConfig: {
    (config: IAMService.Config): <A, E, R>(effect: Effect.Effect<A, E, R>) => Effect.Effect<A, E, R>;
    <A, E, R>(effect: Effect.Effect<A, E, R>, config: IAMService.Config): Effect.Effect<A, E, R>;
};
/**
 * @since 1.0.0
 * @category iam service config
 */
export declare const setIAMServiceConfig: (config: IAMService.Config) => Layer.Layer<never, never, never>;
/**
 * @since 1.0.0
 * @category adapters
 */
export declare const toIAMClientConfig: Effect.Effect<IAMClientConfig>;
//# sourceMappingURL=IAMServiceConfig.d.ts.map