/**
 * @since 1.0.0
 */
import { AddClientIDToOpenIDConnectProviderCommand, AddRoleToInstanceProfileCommand, AddUserToGroupCommand, AttachGroupPolicyCommand, AttachRolePolicyCommand, AttachUserPolicyCommand, ChangePasswordCommand, CreateAccessKeyCommand, CreateAccountAliasCommand, CreateGroupCommand, CreateInstanceProfileCommand, CreateLoginProfileCommand, CreateOpenIDConnectProviderCommand, CreatePolicyCommand, CreatePolicyVersionCommand, CreateRoleCommand, CreateSAMLProviderCommand, CreateServiceLinkedRoleCommand, CreateServiceSpecificCredentialCommand, CreateUserCommand, CreateVirtualMFADeviceCommand, DeactivateMFADeviceCommand, DeleteAccessKeyCommand, DeleteAccountAliasCommand, DeleteAccountPasswordPolicyCommand, DeleteGroupCommand, DeleteGroupPolicyCommand, DeleteInstanceProfileCommand, DeleteLoginProfileCommand, DeleteOpenIDConnectProviderCommand, DeletePolicyCommand, DeletePolicyVersionCommand, DeleteRoleCommand, DeleteRolePermissionsBoundaryCommand, DeleteRolePolicyCommand, DeleteSAMLProviderCommand, DeleteServerCertificateCommand, DeleteServiceLinkedRoleCommand, DeleteServiceSpecificCredentialCommand, DeleteSigningCertificateCommand, DeleteSSHPublicKeyCommand, DeleteUserCommand, DeleteUserPermissionsBoundaryCommand, DeleteUserPolicyCommand, DeleteVirtualMFADeviceCommand, DetachGroupPolicyCommand, DetachRolePolicyCommand, DetachUserPolicyCommand, DisableOrganizationsRootCredentialsManagementCommand, DisableOrganizationsRootSessionsCommand, EnableMFADeviceCommand, EnableOrganizationsRootCredentialsManagementCommand, EnableOrganizationsRootSessionsCommand, GenerateCredentialReportCommand, GenerateOrganizationsAccessReportCommand, GenerateServiceLastAccessedDetailsCommand, GetAccessKeyLastUsedCommand, GetAccountAuthorizationDetailsCommand, GetAccountPasswordPolicyCommand, GetAccountSummaryCommand, GetContextKeysForCustomPolicyCommand, GetContextKeysForPrincipalPolicyCommand, GetCredentialReportCommand, GetGroupCommand, GetGroupPolicyCommand, GetInstanceProfileCommand, GetLoginProfileCommand, GetMFADeviceCommand, GetOpenIDConnectProviderCommand, GetOrganizationsAccessReportCommand, GetPolicyCommand, GetPolicyVersionCommand, GetRoleCommand, GetRolePolicyCommand, GetSAMLProviderCommand, GetServerCertificateCommand, GetServiceLastAccessedDetailsCommand, GetServiceLastAccessedDetailsWithEntitiesCommand, GetServiceLinkedRoleDeletionStatusCommand, GetSSHPublicKeyCommand, GetUserCommand, GetUserPolicyCommand, ListAccessKeysCommand, ListAccountAliasesCommand, ListAttachedGroupPoliciesCommand, ListAttachedRolePoliciesCommand, ListAttachedUserPoliciesCommand, ListEntitiesForPolicyCommand, ListGroupPoliciesCommand, ListGroupsCommand, ListGroupsForUserCommand, ListInstanceProfilesCommand, ListInstanceProfilesForRoleCommand, ListInstanceProfileTagsCommand, ListMFADevicesCommand, ListMFADeviceTagsCommand, ListOpenIDConnectProvidersCommand, ListOpenIDConnectProviderTagsCommand, ListOrganizationsFeaturesCommand, ListPoliciesCommand, ListPoliciesGrantingServiceAccessCommand, ListPolicyTagsCommand, ListPolicyVersionsCommand, ListRolePoliciesCommand, ListRolesCommand, ListRoleTagsCommand, ListSAMLProvidersCommand, ListSAMLProviderTagsCommand, ListServerCertificatesCommand, ListServerCertificateTagsCommand, ListServiceSpecificCredentialsCommand, ListSigningCertificatesCommand, ListSSHPublicKeysCommand, ListUserPoliciesCommand, ListUsersCommand, ListUserTagsCommand, ListVirtualMFADevicesCommand, PutGroupPolicyCommand, PutRolePermissionsBoundaryCommand, PutRolePolicyCommand, PutUserPermissionsBoundaryCommand, PutUserPolicyCommand, RemoveClientIDFromOpenIDConnectProviderCommand, RemoveRoleFromInstanceProfileCommand, RemoveUserFromGroupCommand, ResetServiceSpecificCredentialCommand, ResyncMFADeviceCommand, SetDefaultPolicyVersionCommand, SetSecurityTokenServicePreferencesCommand, SimulateCustomPolicyCommand, SimulatePrincipalPolicyCommand, TagInstanceProfileCommand, TagMFADeviceCommand, TagOpenIDConnectProviderCommand, TagPolicyCommand, TagRoleCommand, TagSAMLProviderCommand, TagServerCertificateCommand, TagUserCommand, UntagInstanceProfileCommand, UntagMFADeviceCommand, UntagOpenIDConnectProviderCommand, UntagPolicyCommand, UntagRoleCommand, UntagSAMLProviderCommand, UntagServerCertificateCommand, UntagUserCommand, UpdateAccessKeyCommand, UpdateAccountPasswordPolicyCommand, UpdateAssumeRolePolicyCommand, UpdateGroupCommand, UpdateLoginProfileCommand, UpdateOpenIDConnectProviderThumbprintCommand, UpdateRoleCommand, UpdateRoleDescriptionCommand, UpdateSAMLProviderCommand, UpdateServerCertificateCommand, UpdateServiceSpecificCredentialCommand, UpdateSigningCertificateCommand, UpdateSSHPublicKeyCommand, UpdateUserCommand, UploadServerCertificateCommand, UploadSigningCertificateCommand, UploadSSHPublicKeyCommand, } from "@aws-sdk/client-iam";
import { Service } from "@effect-aws/commons";
import { Effect, Layer } from "effect";
import { AllServiceErrors } from "./Errors.js";
import * as Instance from "./IAMClientInstance.js";
import * as IAMServiceConfig from "./IAMServiceConfig.js";
const commands = {
    AddClientIDToOpenIDConnectProviderCommand,
    AddRoleToInstanceProfileCommand,
    AddUserToGroupCommand,
    AttachGroupPolicyCommand,
    AttachRolePolicyCommand,
    AttachUserPolicyCommand,
    ChangePasswordCommand,
    CreateAccessKeyCommand,
    CreateAccountAliasCommand,
    CreateGroupCommand,
    CreateInstanceProfileCommand,
    CreateLoginProfileCommand,
    CreateOpenIDConnectProviderCommand,
    CreatePolicyCommand,
    CreatePolicyVersionCommand,
    CreateRoleCommand,
    CreateSAMLProviderCommand,
    CreateServiceLinkedRoleCommand,
    CreateServiceSpecificCredentialCommand,
    CreateUserCommand,
    CreateVirtualMFADeviceCommand,
    DeactivateMFADeviceCommand,
    DeleteAccessKeyCommand,
    DeleteAccountAliasCommand,
    DeleteAccountPasswordPolicyCommand,
    DeleteGroupCommand,
    DeleteGroupPolicyCommand,
    DeleteInstanceProfileCommand,
    DeleteLoginProfileCommand,
    DeleteOpenIDConnectProviderCommand,
    DeletePolicyCommand,
    DeletePolicyVersionCommand,
    DeleteRoleCommand,
    DeleteRolePermissionsBoundaryCommand,
    DeleteRolePolicyCommand,
    DeleteSAMLProviderCommand,
    DeleteSSHPublicKeyCommand,
    DeleteServerCertificateCommand,
    DeleteServiceLinkedRoleCommand,
    DeleteServiceSpecificCredentialCommand,
    DeleteSigningCertificateCommand,
    DeleteUserCommand,
    DeleteUserPermissionsBoundaryCommand,
    DeleteUserPolicyCommand,
    DeleteVirtualMFADeviceCommand,
    DetachGroupPolicyCommand,
    DetachRolePolicyCommand,
    DetachUserPolicyCommand,
    DisableOrganizationsRootCredentialsManagementCommand,
    DisableOrganizationsRootSessionsCommand,
    EnableMFADeviceCommand,
    EnableOrganizationsRootCredentialsManagementCommand,
    EnableOrganizationsRootSessionsCommand,
    GenerateCredentialReportCommand,
    GenerateOrganizationsAccessReportCommand,
    GenerateServiceLastAccessedDetailsCommand,
    GetAccessKeyLastUsedCommand,
    GetAccountAuthorizationDetailsCommand,
    GetAccountPasswordPolicyCommand,
    GetAccountSummaryCommand,
    GetContextKeysForCustomPolicyCommand,
    GetContextKeysForPrincipalPolicyCommand,
    GetCredentialReportCommand,
    GetGroupCommand,
    GetGroupPolicyCommand,
    GetInstanceProfileCommand,
    GetLoginProfileCommand,
    GetMFADeviceCommand,
    GetOpenIDConnectProviderCommand,
    GetOrganizationsAccessReportCommand,
    GetPolicyCommand,
    GetPolicyVersionCommand,
    GetRoleCommand,
    GetRolePolicyCommand,
    GetSAMLProviderCommand,
    GetSSHPublicKeyCommand,
    GetServerCertificateCommand,
    GetServiceLastAccessedDetailsCommand,
    GetServiceLastAccessedDetailsWithEntitiesCommand,
    GetServiceLinkedRoleDeletionStatusCommand,
    GetUserCommand,
    GetUserPolicyCommand,
    ListAccessKeysCommand,
    ListAccountAliasesCommand,
    ListAttachedGroupPoliciesCommand,
    ListAttachedRolePoliciesCommand,
    ListAttachedUserPoliciesCommand,
    ListEntitiesForPolicyCommand,
    ListGroupPoliciesCommand,
    ListGroupsCommand,
    ListGroupsForUserCommand,
    ListInstanceProfileTagsCommand,
    ListInstanceProfilesCommand,
    ListInstanceProfilesForRoleCommand,
    ListMFADeviceTagsCommand,
    ListMFADevicesCommand,
    ListOpenIDConnectProviderTagsCommand,
    ListOpenIDConnectProvidersCommand,
    ListOrganizationsFeaturesCommand,
    ListPoliciesCommand,
    ListPoliciesGrantingServiceAccessCommand,
    ListPolicyTagsCommand,
    ListPolicyVersionsCommand,
    ListRolePoliciesCommand,
    ListRoleTagsCommand,
    ListRolesCommand,
    ListSAMLProviderTagsCommand,
    ListSAMLProvidersCommand,
    ListSSHPublicKeysCommand,
    ListServerCertificateTagsCommand,
    ListServerCertificatesCommand,
    ListServiceSpecificCredentialsCommand,
    ListSigningCertificatesCommand,
    ListUserPoliciesCommand,
    ListUserTagsCommand,
    ListUsersCommand,
    ListVirtualMFADevicesCommand,
    PutGroupPolicyCommand,
    PutRolePermissionsBoundaryCommand,
    PutRolePolicyCommand,
    PutUserPermissionsBoundaryCommand,
    PutUserPolicyCommand,
    RemoveClientIDFromOpenIDConnectProviderCommand,
    RemoveRoleFromInstanceProfileCommand,
    RemoveUserFromGroupCommand,
    ResetServiceSpecificCredentialCommand,
    ResyncMFADeviceCommand,
    SetDefaultPolicyVersionCommand,
    SetSecurityTokenServicePreferencesCommand,
    SimulateCustomPolicyCommand,
    SimulatePrincipalPolicyCommand,
    TagInstanceProfileCommand,
    TagMFADeviceCommand,
    TagOpenIDConnectProviderCommand,
    TagPolicyCommand,
    TagRoleCommand,
    TagSAMLProviderCommand,
    TagServerCertificateCommand,
    TagUserCommand,
    UntagInstanceProfileCommand,
    UntagMFADeviceCommand,
    UntagOpenIDConnectProviderCommand,
    UntagPolicyCommand,
    UntagRoleCommand,
    UntagSAMLProviderCommand,
    UntagServerCertificateCommand,
    UntagUserCommand,
    UpdateAccessKeyCommand,
    UpdateAccountPasswordPolicyCommand,
    UpdateAssumeRolePolicyCommand,
    UpdateGroupCommand,
    UpdateLoginProfileCommand,
    UpdateOpenIDConnectProviderThumbprintCommand,
    UpdateRoleCommand,
    UpdateRoleDescriptionCommand,
    UpdateSAMLProviderCommand,
    UpdateSSHPublicKeyCommand,
    UpdateServerCertificateCommand,
    UpdateServiceSpecificCredentialCommand,
    UpdateSigningCertificateCommand,
    UpdateUserCommand,
    UploadSSHPublicKeyCommand,
    UploadServerCertificateCommand,
    UploadSigningCertificateCommand,
};
/**
 * @since 1.0.0
 * @category constructors
 */
export const makeIAMService = Effect.gen(function* () {
    const client = yield* Instance.IAMClientInstance;
    return Service.fromClientAndCommands(client, commands, {
        errorTags: AllServiceErrors,
        resolveClientConfig: IAMServiceConfig.toIAMClientConfig,
    });
});
/**
 * @since 1.0.0
 * @category models
 */
export class IAMService extends Effect.Tag("@effect-aws/client-iam/IAMService")() {
    static defaultLayer = Layer.effect(this, makeIAMService).pipe(Layer.provide(Instance.layer));
    static layer = (config) => Layer.effect(this, makeIAMService).pipe(Layer.provide(Instance.layer), Layer.provide(IAMServiceConfig.setIAMServiceConfig(config)));
    static baseLayer = (evaluate) => Layer.effect(this, makeIAMService).pipe(Layer.provide(Layer.effect(Instance.IAMClientInstance, Effect.map(IAMServiceConfig.toIAMClientConfig, evaluate))));
}
//# sourceMappingURL=IAMService.js.map